.nh
.de Sp
.if t .sp .5v
.if n .sp
..
.de Ip
.br
.ie \\n.$>=3 .ne \\$3
.el .ne 3
.IP "\\$1" \\$2
..
.TH PLOD 1 "2 November 1994" "PLOD"
.SH NAME
plod \- keep a log of your work
.SH SYNOPSIS
.B plod
\ [\ -s\ ]\ [\ -f \fIfile\fR\ ]\ <-b \fIjobname\fR | -B |
.br
\ \ \ \ \ \ \ -j \fIjob\fR [ -t \fItimespent\fR ] | -J [ -t
\fItimespent\fR ] |
.br
\ \ \ \ \ \ \ -e [ -t \fItimespent\fR ]> [\ \fIone line message\fR\ ]
.br
.B plod
\ [\ -s\ ]\ [\ -f \fIfile\fR\ ]
\fB-C\fR|\fB-E\fR|\fB-P\fR|\fB-V\fR\|\fB-S\fR [\ \fIlogfile\fR\
[\ \fIkey\fR\ ]]
.br
.B plod
\ [\ -s\ ]\ [\ -f \fIfile\fR\ ]
[ -d \fIstartdate\fR ]
.br
\ \ \ \ \ \ [ -D \fIenddate\fR ]
\fB-g\fR|\fB-G\fR\ \fIpattern\fR\ [\ \fIlogfile\fR\ [\ \fIkey\fR\ ]]
.br
.B plod
\ [\ -s\ ]\ [\ -f \fIfile\fR\ ]
[ -d \fIstartdate\fR ]
.br
\ \ \ \ \ \ [ -D \fIenddate\fR ]
\fB-T\fR [\ \fIlogfile\fR\ [\ \fIkey\fR\ ]]

.SH DESCRIPTION
\fBPLOD\fR
is a tool developed to help System/Network Administrators (and others)
keep track of the work that they do.  Good logs are useful both as a
personal reference and to show to your management on a regular basis
or around performance review time. By default, logs will be stored in
an encrypted format in the directory \fI$HOME/.logdir\fR, but this
behavior is completely customizable (see \fBENVIRONMENT\fR and 
\fBCUSTOMIZATION\fR below).

The first form of the command will enter a short message on the command
line into your log file.  If no message is present on the command line,
a date/time stamp will be printed and \fBPLOD\fR
will go into an interactive mode reminiscent of BSD mail.  Many tilde
escape sequences are supported (see \fBCOMMANDS\fR below or type 
\fI~h\fR or \fI~?\fR within interactive mode).  Enter a period on a
line by itself to end your log entry.

The first mode also permits you to store time information with your
log entries automatically. These job commands start timing a job,
suspend or resume timing a job (to go to lunch), record temporarily
diversions from a job (to answer a question or take a phone call) and
end timing a job (see \fBTIMING COMMANDS\fR below).

The second mode allows you to review or edit your old log files.  The
\fB-P\fR option invokes the default \fBPAGER\fR defined in the \fBPLOD\fR
source, or as defined in your environment, on the current log file.  The
\fB-E\fR and \fB-V\fR flags invoke \fBEDITOR\fR and \fBVISUAL\fR respectively.
The \fB-C\fR option will simply dump the current log file to the
standard output.  This is useful for piping your log file to other
commands, such as \fBlpr\fR.
Older log files may be accessed by specifying a file name and optional
encryption key on the command line.

The third mode allows you to search your logs for a particular pattern
but, unlike \fBgrep\fR(1), \fBPLOD\fR displays the entire log entry
rather than just the line which matches the pattern.
The \fB-g\fR flag specifies a case-insensitive match, while \fB-G\fR
does a case sensitive search.  The \fIpattern\fR may be any valid Perl
regular expression.  Don't forget to quote the pattern to protect
any special characters from the shell.
The \fB-d\fR and \fB-D\fR options let you
filter the result of the grep by date. The \fIstartdate\fR and
\fIenddate\fR arguments accept dates in the form 'mm/dd/yyyy'.

The fourth mode creates a timecard that tells you how much time was
spent on an individual job. Again the \fB-d\fR and \fB-D\fR options
allows you to restrict the dates that get entered into the
timecard. The \fB-F\fR option determines the format for the time. For
more information see \fBTIMING COMMANDS\fR below.

In any mode, the \fB-f\fR flag allows the user to specify a different
startup file than the default (\fI$HOME/.plodrc\fR).  The \fB-s\fR
flag tells \fBPLOD\fR to prompt the user for their encryption key.
When making a one-line log entry, the \fB-f\fR and \fB-s\fR options must
appear first on the command line.

.SH ENVIRONMENT
\fBPLOD\fR supports a number of variables which can be modified to customize
its behavior.  The values of these variables may be changed by editing
\fBPLOD\fR directly, by assignment in a system-wide startup file, 
by creating an environment variable, or by assignment
in the user's startup file (see \fBCUSTOMIZATION\fR below).  \fBPLOD\fR
recognizes the following environment variables:
.Ip "\fBSEPARATOR\fR" 4
A string used to separate one entry from another in the log file.  This
string must be constant throughout the entire file or the \fB-g\fR and
\fB-G\fR command line options will not work correctly.  Default is
\fI-----\fR (five dashes).
.Ip "\fBGENSTAMP\fR" 4
This variable is perl code that when run defines the
Time/Date/Job/Timespent stamp entered into every log entry.  Set this
to null if you do not wish to datestamp your logs.  Setting it to null
will disable all of the timing commands as well. The default format is
\fIMM/DD/YY, HH:MM -- Job Timespent\fR.
.Sp
.Ip "\fBSTAMP\fR" 4
The time/date stamp entered into every log entry.  This is not defined
by default as it overrides the \fBGENSTAMP\fR variable. Overriding the
GENSTAMP variable will cause problems with the job timing commands.
.Sp
.Ip "\fBSTAMPREGEX\fR" 4
The regular expression that is used to parse the entry's
\fBSTAMP\fR. This is used by the \fB-D\fR and \fB-d\fR options as well
as the \fB-T\fR option.
.Sp
.Ip "\fBPREFIX\fR" 4
String to be prepended to each line of log entry as it goes into your log
file.  Default is the empty string.
.Sp
.Ip "\fBSUFFIX\fR" 4
String to be appended to each line of log entry as it goes into your log
file.  Default is the empty string.
.Sp
.Ip "\fBEDITOR\fR" 4
The user's preferred editor (used by the \fB-E\fR command line flag and the
\fB~e\fR, \fB~E\fR, and \fB~M\fR escape sequences).  Default is 
\fI/usr/local/bin/emacs\fR.
.Sp
.Ip "\fBVISUAL\fR" 4
The user's preferred visual editor (used by \fB-V\fR, \fB~v\fR, and \fB~V\fR).
Default is \fI/usr/local/bin/emacs\fR.
.Sp
.Ip "\fBPAGER\fR" 4
The user's preferred pager (used by \fB-P\fR, \fB~p\fR, and \fB~P\fR).
Default is \fI/usr/local/bin/less\fR.
.Sp
.Ip "\fBLINES\fR" 4
The number of lines on the current display.  Used to determine when the
\fBPAGER\fR needs to be invoked. Default is \fI24\fR.
.Sp
.Ip "\fBCRYPTCMD\fR" 4
The encryption command to be used.  If you do not wish to encrypt your
log files, set this to null.
Default is \fI/bin/crypt\fR (the standard UNIX \fBcrypt\fR command is
not in the least secure, but does provide protection from casual browsing).
.Sp
.Ip "\fBKEYVAL\fR" 4
The key to be used with \fBCRYPTCMD\fR.  Default is \fIpl<yr><mn>od\fR.
.Sp
.Ip "\fBPROMPT\fR" 4
Setting this variable to true (non-zero) causes \fBPLOD\fR to prompt
the user for their encryption key rather than using \fBKEYVAL\fR.
This is equivalent to using the \fB-s\fR flag
on the command line.  Default is \fIfalse\fR (zero).
.Sp
.Ip "\fBLOGDIR\fR" 4
Where log files are placed.  Default is \fI$HOME/.logdir\fR.
.Sp
.Ip "\fBLOGFILE\fR" 4
The name of the current log file.  \fBLOGDIR\fR will be prepended to this
value if \fBLOGFILE\fR is not an absolute path.  Default is
\fI<yr><mn>\fR.
.Sp
.Ip "\fBHOME\fR" 4
The user's home directory.  Default taken from user's password entry.
.Sp
.Ip "\fBPLODRC\fR" 4
The name of the user's startup file.  Can also be set with
the \fB-f\fR command line switch.  Obviously, there isn't a lot of
point in trying to set this in your \fI.plodrc\fR file.  \fBHOME\fR
will be prepended
to this value of \fBPLODRC\fR is not an absolute path.  Default
is \fI.plodrc\fR.
.Sp
.Ip "\fBPLODJRC\fR" 4
The name of the file holding the current job name and timing
information.  \fBHOME\fR will be prepended to this value of
\fBPLODRC\fR is not an absolute path.  Default is \fI.plodjob\fR.
.Sp
.Ip "\fBTIMESPENT\fR" 4
The default amount of time that will be recorded for a job enrty done
using the \fB-j\fR option. It can be overridden with the \fB-t\fR
\fItimespent\fR option. The \fItimespent\fR argument should be the
number of minutes spent on the job. The default is 15 minutes.
.Sp
.Ip "\fBBACKUP\fR" 4
The current \fBLOGFILE\fR is copied to \fBBACKUP\fR as the program begins
execution.  If, when the program terminates, the \fBLOGFILE\fR is gone or
zero-length, then it is replaced the the \fBBACKUP\fR copy and the current
log entry is dumped to \fBDEADLOG\fR.  Setting \fBBACKUP\fR to null disables
this feature.  The value of \fBHOME\fR is prepended if \fBBACKUP\fR is
not an absolute path.  Default is \fI.plod<pid>.bak\fR.
.Sp
.Ip "\fBDEADLOG\fR" 4
Where interrupted log entries are placed.  \fBHOME\fR will be prepended
to this value if \fBDEADLOG\fR is not an absolute path.  Default
is \fIdead.log\fR.
.Sp
.Ip "\fBTMPFILE\fR" 4
Scratch file used throughout execution of program.  Default is 
\fI/tmp/plodtmp<pid>\fR.
.Sp

.SH TIMING COMMANDS
The timing commands are used to manipulate timing information for
jobs. The jobs are defined by setting elements of the %Jobs array. For
example adding the line:

.RS
.nf
  $Jobs{'software_install'} = 'software_install';
.fi
.RE

to your .plodrc would alloy you to time the job called
"software_install". Note that "software_install" occurs on both sides
of the = sign. This is important because the item onthe righthand side
of the equals sign is what shows up as the job name in the logs. This
makes it easy to have short aliases for longer names. For example the entry:

.RS
.nf
  $Jobs{'si'} = 'software_install';
.fi
.RE

in your .plodrc makes the alias "si" mean the same thing as
"software_install". This is to prevent you from accidently mistyping a
job name every job you want to use must have an entry in the Jobs
array.  Actually this is a bit of a lie. Entries of the form
"TR:<numbers>" are always accepted. This bit of hackery is present to
allow you to record your time on trouble tickets without having to
enter each trouble ticket in the Jobs array. If you define:

.RS
.nf
  $Jobs{'TR_10241'} = 'TR:DiskSpace';
  $Jobs{'TR_10249'} = 'TR:DiskSpace';
  $Jobs{'TR_10274'} = 'TR:DiskSpace';
.fi
.RE

then any work done on the tickets listed on the left hand side will be
mapped to the TR:Diskspace job in the log. It is suggested that you
set up your trouble ticketing system to define the environment
variable PLODJOB in the form TR:<number> where number is the job that
you are working on solving. Note that the : has a special meaning when
generating timecards. It will be described below.

We have seen how to set up the jobs, so how do the multitude of
options work?  The \fB-B\fR or \fB-b\fR options start the clock
running, timing the number of minutes spent on the job. The \fB-B\fR
option gets its job name from the environment variable \fBPLODJOB\fR
while you must specify the job name on the command line with the
\fB-b\fR option. You can provide a one line message or enter an
interactive message.

From this point on, every message that you enter (until you use the \fB-e\fR
or \fB-J\fR options) will be tagged with the job name. This makes it easy to
use the \fB-G\fR or \fB-G\fR options to find all messages on a job.

Now let's say you have been working all morning on the job and you
want to get lunch. If you were to just leave, the clock would still be
running when you get back and have counted the time you were at lunch
as time spent on the job. The \fB-J\fR option is a toggle. If a job is
active, it suspends it. If the job is suspended it resumes timing
it. The \fB-J\fR option lets you enter a one line or multi-line
message. Only the message with the \fB-J\fR option will be tagged with
the job name. If you run plod without any job options while a job is
suspended, the entry will not be tagged with job information. You must
unsuspend the job using the \fB-J\fR option to enable the job tag on
messages. Now lets say that you have finished with the job for the
time being and you are going to work on another job. Use the \fB-e\fR
option to close out the job and permit another job to be started with
the \fB-b\fR or \fB-B\fR options.

Now let's say that you are working on a job and a phone call comes in
that you need to handle. You could use \fB-e\fR to end the job and
then \fB-b\fR to start a new job, then \fB-e\fR to end the new job and
\fB-b\fR to restart the one you are working on. However that is a
hassle. That's where the \fB-j\fR option comes in. Using "\fB-j\fR
\fIjobname\fR" creates a plod entry for jobname without the hassle of
\fB-b\fR and \fB-e\fR. Using the "\fB-t\fR \fItimespent\fR" option
with it allows you to set the number of minutes you spent on the
job. The environment and perl variable \fBTIMESPENT\fI
(\fB$TIMESPENT\fR), which is set to 15 by default, determines the
default amount of time if you do not use the "\fB-t\fR
\fItimespent\fR" option. Now one other little trick happens. The
amount of time spent on the "\fB-j\fR \fIjobname\fR" option is
automatically subtracted from the current job specified by the
\fB-B\fR or \fB-b\fR flag if the the job is active (i.e. not suspended
by the \fB-J\fR option).

The \fB-t\fR option can also change time when used with \fB-J\fR and
\fB-e\fR.  If the \fItimespent\fR argument starts with a \fB+\fR or
\fB-\fR sign, then that number of minutes is added to or subtracted
from the time spent on the job. This allows you to adjust the time
spent if you went out to lunch and forgot to use \fB-J\fR to suspend
the clock. Just use \fB-J -t -60\fR to reduce the reported time by 60
minutes (don't forget to unsuspend the job and restart the timer). If
you don't remeber the current job status, use the \fB-S\fR option. To
summarize the options:
.RS
.Ip "\fB-b\fR \fIjobname\fR"
begin work on new current job. If called as: \fB-b
\\?\fR or just \fB-b\fR the defined jobs are listed.
.Sp
.Ip \fB-B\fR
begin work on new current job. Environment variable $PLODJOB
defines job name
.Sp
.Ip \fB-J\fR
suspend/resume work on current job
.Sp
.Ip "\fB-j\fR \fIjobname\fR"
record some work on job interrupting current job. Modifies timing
on current job unless current job is suspended. If called as: \fB-j
\\?\fR or just \fB-j\fR the defined jobs are listed sorted
alphabetically in 4 columns. If you set \fB$JobListOrder\fR to 1, the
jobs will be sorted alphabetically by rows.
.Sp
.Ip \fB-e\fR
end work on current job
.Sp
.Ip \fB-S\fR
report current status of job
.Sp
.RE

Now that we have this timing info what can we do with it? Well I am
glad you asked. The \fB-T\fR option generates a timecard listing jobs
on the left hand side and cumulative time on the right. The format of
the time is controlled by the \fB-F\fR option. It can be set to:
"\fIh\fR" for hours and decimal hours, "\fIh:m\fR" for hours and
minutes or "\fIm\fR" for minutes.  The \fB-d\fR and \fB-D\fR options take
dates in the form '\fImm/dd/yyyy\fR' and only select the entries that fall
after the \fB-d\fR date and before the \fB-D\fR date.

Jobs that have a ':' in them are treated as a category and
subcategory. Sums are computed for both of them. As an example:

.RS
.nf
Programming:                 3:50
Programming:c                0:10
Programming:perl             3:40
TR:                          0:30
TR:23                        0:10
TR:32                        0:20
zTOTAL =                     4:20
.fi
.RE

the total for all TR's was 30 minutes and all programming projects was
3:50. The \fB-T\fR option also computes a total for all jobs. It is
listed as '\fIzTOTAL =\fR' at the bottom.

In brief:

.RS
.Ip \fB-T\fR
report amount of time for all jobs (Timecard)
.Sp
.Ip "\fB-F\fR \fIformat\fR"
format for time. 'h' hours, 'm' minutes, 'h:m' hours and minutes.
.Sp
.Ip "\fB-d\fR \fImm/dd/yyyy\fR"
only return entries after this date.
.Sp
.Ip "\fB-D\fR \fImm/dd/yyyy\fR"
only return entries before this date.
.Sp
.RE

.SH COMMANDS
Many tilde escape sequences are supported under \fBPLOD\fR's interactive
mode.  Users may also define their own escape sequences in \fBPLOD\fR's
initialization file (see \fBCUSTOMIZATION\fR below).  Currently defined
sequences are:
.Ip "~h, ~?" 8
Show a list of all escape sequences with a short usage message.
.Sp
.Ip "~= var[, ...]" 8
Display the current value of one or more variables.
.Ip "~e [editor]" 8
Edit the current buffer with \fBeditor\fR or \fB$EDITOR\fR if \fBeditor\fR
not specifed.
.Sp
.Ip ~v 8
Edit the current buffer with \fB$VISUAL\fR.
.Sp
.Ip ~p 8
Display the contents of the current buffer (using \fB$PAGER\fR if necessary).
.Sp
.Ip "~V [\ logfile\ [\ key\ ]]" 8
Call \fB$VISUAL\fR on the current log file, or on some other log file as
specified.  An additional encryption key may also be supplied.
.Sp
.Ip "~E, ~l [\ logfile\ [\ key\ ]]" 8
Similar to ~V except that \fB$EDITOR\fR is used.
.Sp
.Ip "~P, ~L [\ logfile\ [\ key\ ]]" 8
Same as ~E and ~V except that \fB$PAGER\fR is invoked.
.Sp
.Ip ~q 8
Quit \fBPLOD\fR, saving contents of buffer into \fB$DEADLOG\fR.
.Sp
.Ip ~x 8
Quit without attempting to save buffer.
.Sp
.Ip ~d 8
Append contents of \fB$DEADLOG\fR to current buffer.
.Sp
.Ip "~r somefile" 8
Append contents of file to current buffer.
.Sp
.Ip "~a somefile" 8
Append contents of current buffer to file.
.Sp
.Ip "~w somefile" 8
Overwrite file with contents of current buffer.
.Sp
.Ip "~X Perl-code" 8
Execute a line of Perl code.
.Sp
.Ip ~M 8
Invoke \fB$EDITOR\fR and execute resulting file as Perl code.  Each successive
invocation of this escape will edit the previously executed Perl code so as
to make it easier to go back and correct small errors.
.Sp
.Ip "~! command" 8
Execute a command in the shell and return.
.Sp
.Ip "~> command" 8
Append the output of a command to the current buffer.
.Sp
.Ip "~| command" 8
Pipe the current buffer through a command and replace the buffer with the
resulting output.
.Sp

.SH CUSTOMIZATION
Like most UNIX utilities, \fBPLOD\fR has an initialization file,
the \fI\.plodrc\fR,
which is read at startup.  Unlike most UNIX utilities,
this file is interpreted as Perl code.  Thus, if you wished to assign
a new value to a customization variable you would use the syntax
.RS
.PP
$LOGDIR = "$HOME/mylogs";
.RE
.PP
The location of the user startup file may changed with the \fB-f\fR
command line switch or by setting the \fBPLODRC\fR environment variable.

\fBPLOD\fR also looks for a system-wide customization file, \fI/etc/plodrc\fR.
The order of evaluation is: hard coded defaults in \fBPLOD\fR, then
the \fI/etc/plodrc\fR file, then the user's environment, and finally the
user's \fBPLODRC\fR file.

Among the variables tha can be customize is \fI$ShortUsage\fR. This
reduces the Usage message to a specific error and a command line
summary. It eliminates the explanation text when \fI$ShortUsage\fR is
set to 1. Another variable that must be set is the \fI%Jobs\fR array
as described in \fBTIMING COMMANDS\fR if you want to use the timing
commands to track your work.

Beyond simple variable customization, the \fBPLODRC\fR file can be
used as an automatic pre-execution block and to define subroutines
that will be used during the execution of the program.  For
example, \fBPLOD\fR will attempt to execute
user-defined \fI&on_exit()\fR or \fI&on_error()\fR routines (if they
are defined) when the program terminates, depending upon whether the
program exits normally or abnormally.

Another application of this feature is to change the encryption
scheme used by \fBPLOD\fR to use some alternate (more secure) encryption
mechanism.  Encryption and decryption in \fBPLOD\fR are done
via \fI&encrypt()\fR and \fI&decrypt()\fR routines.  Both routines accept
the same three arguments:  a key value, an input file (either encrypted
or decrypted depending upon which routine is being called), and an output
file to place the result into.  The routines must return non-zero upon
success and zero on failure, and should prompt the user for an
encryption key if \fBPROMPT\fR is set.  As an example, here are the default
\fI&encrypt()\fR and \fI&decrypt()\fR routines from the \fBPLOD\fR source:
.RS
.PP
.nf
sub encrypt {
   local($key, $inputfl, $outputfl) = @_;
   local($safekey, $safeinp, $safeout);

   unlink($outputfl);

   if ($PROMPT) {	# Prompt for $KEYVAL if $PROMPT has been set
      print "File is $file.\n";
      print "Please enter encryption key: ";
      system 'stty', '-echo';
      chop($key = <STDIN>);
      system 'stty', 'echo';
      print "\n";
   }   

   ($safekey = $key) =~ s/(\W)/\\$1/g;
   ($safeinp = $inputfl) =~ s/(\W)/\\$1/g;
   ($safeout = $outputfl) =~ s/(\W)/\\$1/g;
   !(system("$CRYPTCMD $safekey < $safeinp >$safeout") >> 8);
}

sub decrypt {
   local($key, $inputfl, $outputfl) = @_;
   local($safekey, $safeinp, $safeout);

   unlink($outputfl);

   if ($PROMPT) {	# Prompt for $KEYVAL if $PROMPT has been set
      print "File is $file.\n";
      print "Please enter encryption key: ";
      system 'stty', '-echo';
      chop($key = <STDIN>);
      system 'stty', 'echo';
      print "\n";
   }   

   ($safekey = $key) =~ s/(\W)/\\$1/g;
   ($safeinp = $inputfl) =~ s/(\W)/\\$1/g;
   ($safeout = $outputfl) =~ s/(\W)/\\$1/g;
   !(system("$CRYPTCMD $safekey < $safeinp >$safeout") >> 8);
}
.fi
.RE
.PP
Note that any possible meta characters in the key or in filenames 
are protected from the shell with
backslashes before they are passed to \fIsystem()\fR.  An \fI&encrypt()\fR
or \fI&decrypt()\fR routine defined in the \fBPLODRC\fR will supercede the
default definitions in the \fBPLOD\fR source.

It is also possible for the user to create their own tilde escapes.  First,
create a subroutine which performs the desired function.  Then assign the
type glob which references that function to global array \fI%funcs\fR indexed
by the character of the escape sequence.  Any arguments that the user enters
after the tilde escape will be passed into the function as a single string
in \fI@_\fR.  The list \fI@lines\fR contains the current buffer.

As an example, here is the append to file function (~a) from the \fBPLOD\fR
source:
.RS
.PP
.nf
sub appendfl {
   local($file) = @_;
   if (!open(OUTP, ">> $file")) {
      warn "*** Could not append to file $file\\n";
      return;
   }
   print OUTP @lines;
   close(OUTP);
   print "Wrote ", scalar(@lines), " lines to file $file\\n";
   print "(continue composing note)\\n";
}
$appendfl = "file\\t\\tAppend contents of buffer to file";
$funcs{'a'} = *appendfl;
.fi
.RE
.PP
The scalar variable \fI$appendfl\fR is used by \fBPLOD\fR's help function
(~h or ~?) to provide a descriptive message about the escape sequence.
As a further example, here is \fBPLOD\fR's help function
.RS
.PP
.nf
sub helpuser {
   local($safename);
   $long = (scalar(keys %funcs) >= $LINES) && open(TMP, ">$TMPFILE");
   for (sort keys %funcs) {
      *info = $funcs{$_};
      if ($long) {
         print TMP "~$_ $info\n";
      }
      else { print "~$_ $info\n"; }
   }
   if ($long) {
      close(TMP);
      ($safename = $TMPFILE) =~ s/(\W)/\\$1/g;
      system("$PAGER $safename");
      unlink $TMPFILE;
   }
}
$helpuser = "\t\tPrint this message";
$funcs{'h'} = *helpuser;
$funcs{'?'} = *helpuser;
.fi
.RE
.PP
Note the use of various customization variables as well as the assignment
of the type glob to two different indices of the \fI%funcs\fR array.  Note
also that again we protect any meta characters from the shell.

Note that it is considered good form to \fIreturn()\fR from user defined
subroutines rather than terminating \fBPLOD\fR prematurely.  If you must
abort execution from within a routine, it is recommended that you
call \fI&PLODNormExit()\fR or \fI&PLODBadExit()\fR so that you get
both the \fBBACKUP\fR mechanism and the appropriate \fI&on_exit()\fR
or \fI&on_error()\fR call.

.SH FILES
.PP
.Ip $HOME/.plodrc 24
Default location for users' personal initialization files
.Sp
.Ip /etc/plodrc 24
System-wide initialization file
.Sp
.PP
Various other customizable file locations.

.SH SEE ALSO
.BR perl (1)

.SH AUTHORS
The original idea for \fBPLOD\fR comes from Bill Mendyka
(\fBmendyka@dg-rtp.dg.com\fR).

The current Perl implementation was developed by Hal Pomeranz
(\fBhal@deer-run.com\fR).

An Emacs mode for \fBPLOD\fR was developed by Paul Foley
(\fBpaul@ascent.com\fR), and another by Paul Hudson
(\fBpaulh@harlequin.com\fR).

Additional improvements have been suggested/developed by:
Bobby Billingsley (\fBbobby@dc.dk\fR),
David W Crabb (\fBcrabb@phoenix.Princeton.EDU\fR),
Michel Dignard (\fBdignard@ERE.UMontreal.CA\fR),
John Ellis (\fBellis@rtsg.mot.com\fR),
Bob Gibson (\fBrjg@sco.COM\fR),
Mike Lachowski (\fBmlachow@erenj.com\fR),
Eric Prestemon (\fBecprest@pocorvares.er.usgs.GOV\fR),
Erik E. Rantapaa (\fBrantapaa@math.umn.edu\fR),
Scot Schneebeli (\fBsls@tct.com\fR),
James Tizard (\fBjames@ringo.ssn.flinders.edu.au\fR),
and G. Paul Ziemba (\fBpaul@alantec.com\fR).

.SH BUGS
Any bug reports or suggestions for improvement should be submitted to
Hal Pomeranz via email at \fBhal@deer-run.com\fR.

